;*****************************************************
;*    AVR  *         *
;*****************************************************
;* :              ..                     *
;*  :  AVR Studio v4.13               *
;* :         ATmega16                       *
;*  :                                *
;*   PC0,PC1,PC2,PC3,PC4,PC5,PC6 -  VCC        *
;*   PB5 -  MOSI                                *
;*   PB6 -  MISO                                *
;*   PB7 -  SCK                                 *
;*   PD2,PA5 -  RESET                          *
;*   PD7 -  CLOCK                               *
;*   PD0 -  RX                                  *
;*   PD1 -  TX                                  *
;*   PA4 -                 *
;*   PA5 -                 *
;*   P7 -                             *
;*   PA7 -                    *
;*   XT1,XT2 -             *
;*   PB0,PB4,PD6,RST,AVCC,VCC,VREF -           *
;*             			 *
;*   PB1,PB2,PB3,GND,AGND -        *
;*                                     *
;*                              kotov_ig@mail.ru     *
;*****************************************************
        
		   .nolist
           .include "m16def.inc"
           .list
      
    .equ  XTAL = 3686      ;   
   	.equ  BAUD = 19200     ;   /
   	.equ  NB = ((XTAL*10000)/(16*BAUD)-5)/10

   	.equ  RAMSTART = 0x60 
   	.equ  PSIZE    = 0x40 
    .equ  BUFSIZE  = 0x80   

    ; r0,r1    SPM
	.def  temp1 =  r16     ;  
	.def  temp2 =  r17     ; 
	.def  temp3 =  r18     ; 
	.def  temp4 =  r19     ; 
	.def  udata =  r20     ;   USART
	.def  bytel =  r24     ;   
	.def  byteh =  r25     ;
 	; r27,r26   XH:XL
	; r29,r28   YH:YL
	; r31,r30   ZH:ZL

        ;  
	.equ  f0    =  0       ;f0=1   
	.equ  f1    =  1       ;f1=1(0)    
	    ; -
	.equ  GLED  =  PA4
	.equ  RLED  =  PA5
	.equ  BTN   =  PC7
	.equ  FOUT  =  PD7

           .dseg
		 .org  0x0260
    READBUF:  .byte   BUFSIZE  ;   128 
    WRITEBUF: .byte   BUFSIZE  ;   128  

         .org  0x0360            
    SAVE:     .byte   6        ;     
    FLAG:     .byte   1        ; 

		   .cseg
         .org  0x0000
        jmp  initial       

         .org  0x1000
		rcall goto_new_adr      ;   
		rcall goto_new_adr      ;   
		rcall goto_new_adr      ;  ATmega8535
		rcall goto_new_adr      ;c  ATmega16
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
	    rcall goto_new_adr
	    rcall goto_new_adr
	    rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
     	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
	    rcall goto_new_adr
	    rcall goto_new_adr
	    rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	
         .org  0x1600
goto_int_TOV0:               ;   TOV0
        sts  SAVE+3,byteh    ; 
		in byteh,SREG 	     ;   
		sts  SAVE+4,byteh    ;   
        sts  SAVE+5,bytel    ;   
	    lds  bytel,FLAG
		sbrc bytel,f0
		rjmp gi1
        sbr bytel,1<<f0
		sts FLAG,bytel
		ldi byteh,0x80
		out PORTC,byteh
        ldi byteh,0x7f
		out DDRC,byteh
		sbi PORTD,FOUT
		cbi DDRD,FOUT
		clr bytel
        out  OCR2,bytel
        out  TCNT2,bytel     ; Fcl = Fio
        ldi  bytel,(1<<WGM21)|(1<<CS20)       
        out  TCCR2,bytel     ; TCNT2- CTC
        rjmp gi5
gi1:    sbic PINC,BTN
        rjmp gi2
        sbrs bytel,f1
		rjmp gi3
		cbr bytel,1<<f1
        rjmp gi4
gi2:    sbr bytel,1<<f1
        sts FLAG,bytel
        rjmp gi5
gi3:    cbr bytel,1<<f1
		sts FLAG,bytel
        rjmp gi5
gi4:    sts FLAG,bytel 
		in byteh,PORTC
        ldi bytel,0x7f
		eor byteh,bytel
        out PORTC,byteh
		in byteh,DDRD
        ldi bytel,1<<FOUT
		eor byteh,bytel
        out DDRD,byteh
gi5:    lds bytel,SAVE+5
        lds byteh,SAVE+4
        out SREG,byteh
		lds byteh,SAVE+3
        jmp 0x0009           ;   

waitcmd:                     ;   
        rcall getc           ;     
		cpi   udata,0x1b
		breq  waitcmd
        cpi   udata,'T'      ; 'T'  
		breq  w1
        cpi   udata,'S'      ; 'S'   
        breq  w2
		cpi   udata,'V'      ; 'V'  
        breq  w3
		cpi   udata,'v'      ; 'v'  
        breq  w4
		cpi   udata,'t'      ; 't'  
        breq  w5
		cpi   udata,'p'      ; 'p'  
        breq  w6
        cpi   udata,'a'      ; 'a'    
        breq  w7 
        cpi   udata,'b'      ; 'b'    
        breq  w8
		cpi   udata,'t'      ; 't'   
		breq  waitcmd
		cpi   udata,'P'      ; 'P'   
        breq  w9
        cpi   udata,'B'      ; 'B'   
        breq  w10
		cpi   udata,'g'      ; 'g'   
        breq  w11
		cpi   udata,'A'      ; 'A'  
        breq  w12
		cpi   udata,'L'      ; 'L'    
        breq  w13
		cpi   udata,'E'      ; 'E'  
        breq  w14
		cpi   udata,'e'      ; 'e'  
        breq  w15
		cpi   udata,'f'      ; 'f'   
        breq  w16
		cpi   udata,'s'      ; 's'  
        breq  w17
		cpi   udata,'F'      ; 'F'    
        breq  w18
        cpi   udata,'N'      ; 'N'    
        breq  w19
		cpi   udata,':'      ; ':'  
        breq  w20
	    cpi   udata,'.'      ; '.'   
        breq  w21 
		cpi   udata,'r'      ; 'r'   
		breq  w22
		cpi   udata,'l'      ; 'l'   
        brne  w23
	    rjmp  put_err

w1:     rjmp  device_type
w2:     rjmp  ret_soft_inform
w3:     rjmp  ret_soft_version
w4:     rjmp  ret_hard_version
w5:     rjmp  show_sup_device
w6:     rjmp  ret_prog_type
w7:     rjmp  ret_adress_inc
w8:     rjmp  ret_enheced_mode
w9:     rjmp  enter_prog_mode
w10:    rjmp  block_write_mem
w11:    rjmp  block_read_mem
w12:    rjmp  load_address
w13:    rjmp  leave_prog_mod
w14:    rjmp  exit
w15:    rjmp  chip_erase
w16:    rjmp  write_fusebits
w17:    rjmp  read_signeture
w18:    rjmp  read_low_fuse
w19:    rjmp  read_high_fuse
w20:    rjmp  univ_command
w21:    rjmp  new_univ_command
w22:    rjmp  read_lockbits
w23:    rjmp  write_lockbits

device_type:
        rcall getc
        rjmp  put_ret		

ret_soft_inform:
        ldi   ZL,low(2*ID_Str)   ; "AVR ISP"
        ldi   ZH,high(2*ID_Str) 
        rcall put_string   
        rjmp  waitcmd

ret_soft_version:
        ldi   ZL,low(2*SW_Ver)   ; "02"
        ldi   ZH,high(2*SW_Ver) 
        rcall put_string         
        rjmp  waitcmd

ret_hard_version:                
        ldi   ZL,low(2*HW_Ver)   ; "03"
        ldi   ZH,high(2*HW_Ver) 
        rcall put_string   
        rjmp  waitcmd

ret_prog_type:
        ldi   udata,'S'          ;  ISP
        rcall putc
        rjmp  waitcmd

ret_adress_inc:
        ldi   udata,'Y'          ;   
        rcall putc
        rjmp  waitcmd
		
show_sup_device:
        ldi   ZL,low(2*DEV_Mega) ;  ATmega16 
        ldi   ZH,high(2*DEV_Mega) 
        rcall put_string   
        clr   udata
        rcall putc
        rjmp  waitcmd

ret_enheced_mode:
        ldi   udata,'Y'          ;   
        rcall putc
        ldi   udata,high(BUFSIZE)
        rcall putc
        ldi   udata,low(BUFSIZE) 
        rcall putc
        rjmp  waitcmd

enter_prog_mode:                     
        rjmp  put_ret

block_write_mem:
        rcall getc                
        tst   udata 
        breq  bw1
        rjmp  put_err
bw1:    rcall getc               
        mov   temp1,udata     
        rcall getc               
        mov   temp2,udata     
        ldi   XH,high(WRITEBUF)
        ldi   XL,low(WRITEBUF) 
bw2:    rcall getc               
        st    X+,udata          
		dec   temp1
        brne  bw2
        ldi   XH,high(WRITEBUF)
        ldi   XL,low(WRITEBUF) 
        cpi   temp2,'F'      
        breq  write_block_flash
        cpi   temp2,'E'      
        breq  write_block_eeprom     
        rjmp  put_err

write_block_flash:
        rcall write_page_spm
        rjmp  put_ret

write_block_eeprom:
        rjmp  put_ret

block_read_mem:
        rcall getc
		mov byteh,udata          
        rcall getc
		mov bytel,udata            
        rcall getc           
        cpi   udata,'F'      
        breq  read_block_flash
        cpi   udata,'E'      
        breq  read_block_eeprom  
        rjmp  put_err

read_block_eeprom:
        ldi udata,0xff
		rcall putc
		sbiw byteh:bytel,0x01
		brne read_block_eeprom
        rjmp  waitcmd
      
read_block_flash: 
        push byteh
        push bytel
        rcall read_page_spm
		pop bytel
        pop byteh
		ldi  XH,high(READBUF)
        ldi  XL,low(READBUF)
rb1:	ld udata,X+
        rcall putc
        ld udata,X+
		rcall putc
		adiw YH:YL,0x01
		sbiw byteh:bytel,0x02
		brne rb1
	    rjmp  waitcmd

load_address:
        rcall getc           
        mov   YH,udata
        rcall getc           
        mov   YL,udata
		rjmp  put_ret

univ_command:
        rcall getc
		mov temp1,udata
        rcall getc
		mov temp2,udata
        rcall getc   
		cpi temp1,0x38   ; 
		brne un1
		cpi temp2,0x00  
		brne un1
		ldi udata,0x77
		rcall putc
		rjmp  put_ret
un1:    cpi temp1,0x58   ; 
		brne un2
	    cpi temp2,0x00  
		brne un2
		ldi udata,0xff
		rcall putc
		rjmp  put_ret
un2:	cpi temp1,0x58   ;   
		brne un3
	    cpi temp2,0x08  
		brne un3
		ldi udata,0xd8
		rcall putc
		rjmp  put_ret
un3:    cpi temp1,0x50   ;   
		brne un4
		cpi temp2,0x00  
		brne un4
		ldi udata,0x1c
		rcall putc
		rjmp  put_ret
un4:    ldi udata,0xff
		rcall putc
		rjmp  put_ret
    

new_univ_command:
		rcall getc
        rcall getc
        rcall getc
		rcall getc
		ldi udata,0xff
		rcall putc
        rjmp  put_ret

leave_prog_mod:
        rjmp  put_ret   
     
exit:  
        rjmp put_ret 

chip_erase:
        rjmp  put_ret

write_mem_page:
        rjmp  put_ret

write_fusebits:
        rcall getc 
		rjmp  put_ret  
		        
read_signeture:
        ldi  udata,0x03  ;  
		rcall putc
		ldi  udata,0x94
		rcall putc
		ldi  udata,0x1e
		rcall putc
        rjmp  waitcmd

read_low_fuse:
        ldi udata,0x1c
		rcall putc
		rjmp  waitcmd

read_high_fuse:
        ldi udata,0xd8
		rcall putc
		rjmp  waitcmd

		
read_ext_fuse:
		ldi udata,0xff
        rcall putc           
        rjmp  waitcmd
     		     
read_lockbits:
        ldi udata,0xff
		rcall putc
		rjmp  waitcmd

write_lockbits:
        rcall getc
		rjmp  put_ret 

put_ret:
        ldi   udata,0x0d      
        rcall putc             
        rjmp  waitcmd

put_err:
        ldi   udata,'?'       
        rcall putc             
        rjmp  waitcmd

usart_init: 
		clr  temp1
        out  UBRRH,temp1
        ldi  temp1,NB   
        out  UBRRL,temp1
        ldi  temp1,(1<<RXEN)|(1<<TXEN)   
		out  UCSRB,temp1
        ldi  temp1,(1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1)
        out  UCSRC,temp1
        ret

getc:   
		sbis  UCSRA,RXC         
		rjmp  getc
        in    udata,UDR 
        ret

putc:     
		sbis  UCSRA,UDRE 
        rjmp  putc     
        out   UDR,udata 
        ret

put_string:
        lpm
        tst   r0
        breq  ps1     
		mov   udata,r0
        rcall putc       
        adiw  ZL,1      
        rjmp  put_string
ps1:    ret

DEV_Mega:
        .db  0x74,0        ;ATmega16

SW_Ver:
        .db "02",0,0

HW_Ver:
        .db "03",0,0

ID_Str:
        .db "AVR ISP",0


          .org  0x1800
goto_new_adr:               
        sts SAVE,byteh      ;  
		in byteh,SREG       ;  rjmp,rcall
		cli
		sts SAVE+1,byteh
        sts SAVE+2,bytel
		pop byteh
		pop bytel
		subi bytel,0x01
		sbci byteh,0x10
		push bytel
		push byteh
		lds bytel,SAVE+2
        lds byteh,SAVE+1
		out SREG,byteh
		lds byteh,SAVE
        ret
 	
    	rcall goto_new_adr      ;   
		rcall goto_new_adr      ;   
		rcall goto_new_adr      ;  ATmega8535
		rcall goto_new_adr      ;c  ATmega16
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr   
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr   
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr   
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr   
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	
		 .org  0x1c00
        jmp initial        ;   
		jmp bad_interrupt  ;  
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp goto_int_TOV0  ;   TCNT0
		jmp bad_interrupt 
		jmp 0x000b         ;   
		jmp 0x000c         ;   UDR
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 
		jmp bad_interrupt 

bad_interrupt:
        rjmp 0x1c00

initial:
        ldi  temp1,high(RAMEND)
        out  SPH,temp1    
        ldi  temp1,low(RAMEND)
        out  SPL,temp1
	    cbi  DDRC,BTN
		sbi  PORTC,BTN 
        rcall usart_init
		sbic PINC,BTN
		rjmp in1
		cbi  PORTA,GLED 
		sbi  DDRA,GLED
		jmp  waitcmd 
in1:    ldi  temp1,1<<IVCE       ;    
		out  GICR,temp1 
		ldi  temp1,1<<IVSEL
		out  GICR,temp1
		clr  temp1
		sts  FLAG,temp1 
		jmp  0x0000

write_page_spm:		
		ldi  XH,high(WRITEBUF)
        ldi  XL,low(WRITEBUF)
        ldi  temp4,(1<<PGERS)|(1<<SPMEN)
		movw ZH:ZL,YH:YL 
		lsl  ZL
		rol  ZH
		rcall do_spm
		ldi  bytel,PAGESIZE
		clr  ZL
		clr  ZH
wp1:	ld r0,X+
		ld r1,X+
 	    ldi temp4,1<<SPMEN
		rcall do_spm
		adiw ZH:ZL,0x02
		dec bytel
		brne wp1
		ldi temp4,(1<<PGWRT)|(1<<SPMEN)
		movw  ZH:ZL,YH:YL
		lsl ZL
		rol ZH
		rcall do_spm
wp2:	in temp3,SPMCR
		sbrc temp3,SPMEN
		rjmp wp2
		ldi temp4,(1<<RWWSRE)|(1<<SPMEN)
		call do_spm
		ret

read_page_spm:
        ldi temp4,(1<<RWWSRE)|(1<<SPMEN)
		call do_spm
	    movw  ZH:ZL,YH:YL
        ldi  XH,high(READBUF)
        ldi  XL,low(READBUF)
		lsl ZL
		rol ZH 
rp1:	lpm r0,Z+
		st X+,r0
		lpm r0,Z+ 
		st X+,r0
		sbiw byteh:bytel,0x02
		brne rp1
		ret
do_spm: 

        in temp3,SPMCR
		sbrc temp3,SPMEN
		rjmp do_spm
		out SPMCR,temp4
		spm
        ret

		rcall goto_new_adr      ;   
		rcall goto_new_adr      ;   
		rcall goto_new_adr      ;  ATmega8535
		rcall goto_new_adr      ;c  ATmega16	
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
        rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr   
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
	    rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    	rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
		rcall goto_new_adr
    
